with Ada.Integer_Text_IO;
with Ada.Strings.Fixed;
use  Ada.Strings.Fixed;
package body Model_Viewer.Counter_Box_View is

   procedure Create (Counter_Box  :    out Counter_Box_View_Ptr;
                     What_I_Watch : in     Model_Ptr;
                     For_Box      : in     Character;
                     File_Name    : in     String) is
   begin
      Counter_Box                 := new Counter_Box_View_Type;
      Counter_Box.all.My_Model    := What_I_Watch;
      Counter_Box.all.My_Box_Char := For_Box;
      Counter_Box.all.My_File     := new Ada.Text_IO.File_Type;

      Ada.Text_IO.Create (File => Counter_Box.all.My_File.all,
                          Name => File_Name);
      Add_Dependent (Model => What_I_Watch.all,
                     View  => View_Ptr(Counter_Box));
   end Create; 


   procedure Update (Counter_Box : in out Counter_Box_View_Type) is 
   begin
      Ada.Text_IO.Put (File => Counter_Box.My_File.all,
                       Item => 20 * Counter_Box.My_Box_Char);
      Ada.Text_IO.New_Line(File => Counter_Box.My_File.all);
      Ada.Integer_Text_IO.Put (File => Counter_Box.My_File.all,
                               Item => Value(Counter_Box.My_Model.all));
      Ada.Text_IO.New_Line(File => Counter_Box.My_File.all);
      Ada.Text_IO.Put (File => Counter_Box.My_File.all,
                       Item => 20 * Counter_Box.My_Box_Char);
      Ada.Text_IO.New_Line (File    => Counter_Box.My_File.all,
                            Spacing => 3);
   end Update; 

end Model_Viewer.Counter_Box_View;
