with Ada.Integer_Text_IO;
with Ada.Strings.Fixed;
use  Ada.Strings.Fixed;
package body Model_Viewer.Counter_Line_View is

   procedure Create (Counter_Line : in out Counter_Line_View_Ptr;
                     What_I_Watch : in     Model_Ptr;
                     For_Line     : in     Character;
                     File_Name    : in     String) is
   begin
      Counter_Line                  := new Counter_Line_View_Type;
      Counter_Line.all.My_Model     := What_I_Watch;
      Counter_Line.all.My_Line_Char := For_Line;
      Counter_Line.all.My_File      := new Ada.Text_IO.File_Type;
      Ada.Text_IO.Create (File => Counter_Line.all.My_File.all,
                          Name => File_Name);
      Add_Dependent (Model => What_I_Watch.all,
                     View  => View_Ptr(Counter_Line));
   end Create; 


   procedure Update (Counter_Line : in out Counter_Line_View_Type) is 
   begin
      Ada.Text_IO.Put (File => Counter_Line.My_File.all,
                       Item => "The count's value is ");
      Ada.Text_IO.Put (File => Counter_Line.My_File.all,
                       Item => 3 * Counter_Line.My_Line_Char);
      Ada.Text_IO.Put (File => Counter_Line.My_File.all,
                       Item => ' ');
      Ada.Integer_Text_IO.Put (File  => Counter_Line.My_File.all,
                               Item  => Value(Counter_Line.My_Model.all),
                               Width => 1);
      Ada.Text_IO.Put (File => Counter_Line.My_File.all,
                       Item => ' ');
      Ada.Text_IO.Put (File => Counter_Line.My_File.all,
                       Item => 3 * Counter_Line.My_Line_Char);
      Ada.Text_IO.New_Line (File    => Counter_Line.My_File.all,
                            Spacing => 3);
   end Update; 

end Model_Viewer.Counter_Line_View;
