import java.util.Vector;

public abstract class Model
{
   public Model ()
   {
      myDependents        = new Vector( MAX_DEPENDENTS );
      numberOfDependents = 0;
   }

   public void addDependent( View newDependent )
   {
      if (numberOfDependents < MAX_DEPENDENTS)
      {
         myDependents.addElement( newDependent );
         numberOfDependents = numberOfDependents + 1;
      }
      else
         System.out.println( "I already have too many dependents!" );
   }

   public abstract int value ();

   protected void change ()
   {
      int  i;
      View aDependent;

      for (i = 0; i < numberOfDependents; i++)
      {
         aDependent = (View) myDependents.elementAt(i);
         aDependent.update();
      }
   }

   private Vector myDependents;
   private int    numberOfDependents;

   private static final int MAX_DEPENDENTS = 10;
}
